/* im Falle von MS-DOS: mit v16colc.c und v16colca.obj erstellen! */
/*		(Projekt File!!) */
#define MSDOS		1

#include<stdio.h>
#include<math.h>
#include<string.h>
#include<stdlib.h>

#include"plot\plotsym.h"

#if defined( MSDOS)
#include "plot\plot_dos.h"
#endif

#if defined( ATARI)
#include "plot_tos.h"
#endif

#define F_MAX			5
#define LAENGE			70
#define MAX_ELEMENTE	LAENGE				/* pro Funktion */
#define MAX_DOUBLES	15                /* pro Funktion */

typedef struct elemen
	{
	int typ;
	void* ptr;
	struct elemen* next;
	} ELEMENT;

ELEMENT f[F_MAX][MAX_ELEMENTE];
double constants[F_MAX][MAX_DOUBLES];
char f_string[F_MAX][LAENGE+1];
int anzeigen[F_MAX];

int geht_nicht= 0;
int difcolour = 0;

int maxx, maxy;

double x_left = -10;
double x_right= 10;

double y_bottom=-1;
double y_top = 1;

/*
double y_bottom= PROPORTIONAL;
double y_top = 8;
*/
/* Funktions-prototypen */
double mathe_funktion(double x, ELEMENT*pointer);
double auswert(double x, ELEMENT*erstes, ELEMENT*letztes);
int zeichne_funktion(int fkt_number, double x_step, double y_step, int farbe);
int zeichnen(void);

#define x_pixel(x_wert) (int)runde(((x_wert)-x_left)/x_step)
#define y_pixel(y_wert) (int)runde((y_top-(y_wert))/y_step)

#define runde(x)			floor((x)+.5)


int stellenzahl(long zahl)
	{
	int stelle;
	if(zahl==0) return 1;
	stelle = (int)ceil(log10(labs(zahl)+1)) + (zahl<0);
	return stelle;
	}

/* setzt f_string[nummer] komplett auf 0  AB*/
void init_string(int nummer)
	{
	int i;
	for(i=0; i<=LAENGE; i++)
		f_string[nummer][i]=0;
	}

/* setzt f[nummer]: typ NICHTS, ptr NULL, next auf das wirklich nchste AB*/
void init_fkt(int nummer)
	{
	int i;
	for(i=0; i<MAX_ELEMENTE; i++)
		{
		f[nummer][i].typ = NICHTS;
		f[nummer][i].ptr = NULL;
		f[nummer][i].next = &f[nummer][i+1];
		}
	f[nummer][MAX_ELEMENTE-1].next = NULL;
	}

/* initialisiert alle f AB*/
void init(void)
	{
	int i;
	for(i=0; i<F_MAX; i++)
		{
		init_string(i);
		init_fkt(i);
		anzeigen[i] = 0;
		}
	}

int plot_init(void)
	{
	init();

	plot_system();

	maxspalte= (int)floor((maxx+1)/TEXTBREITE)-1;
	maxzeile = (int)floor((maxy+1)/TEXTHOEHE)-1;

	maxy = maxzeile*TEXTHOEHE - 1;

	if(FARBE(0) != FARBE(1)) difcolour = 1;

	atexit(plot_exit);
	return 0;
	}

/* Programmende wegen str AB*/
void fatal_error(char*str)
	{
	printf("Es hat sich ein schlimmer Fehler ereignet, "
			"ich kann nicht weitermachen.\nEs war bei:\n");
	printf(str);
	WAIT;
	ED;
	exit(1);
	}

/* falls zahl ganz 1, sonst 0 AB*/
int ifganz(double zahl)
	{
	if(fmod(zahl, 1.)!=0) return(0);
	return(1);
	}

/* sucht die passende KLAMMER_ZU, nebenbei setzt diese Funktion
	auch innere Klammer oder Funktionspointer->ptr auf die zugehrigen
		KLAMMER_ZUs, auer natrlich bei FKT AB*/
ELEMENT* kl_zu(ELEMENT* erstes)
	{
	ELEMENT*pointer;
	ELEMENT*pointer_sp;
	for(pointer = erstes->next; pointer->typ!=KLAMMER_ZU; pointer=pointer->next)
		{
		if(pointer==NULL) {printf("\nFehlende KLAMMER_ZU!"); exit(1);return NULL;}
		if(pointer->typ==KLAMMER_AUF || pointer->typ & FKT)
			{
			pointer_sp = pointer->ptr;
			if(pointer_sp==NULL || pointer->typ==FKT) pointer_sp = kl_zu(pointer);
			if(pointer->ptr==NULL) pointer->ptr = pointer_sp;
			pointer = pointer_sp;
			}
		}
	return(pointer);
	}

/* berechnet das Argument einer Funktion, und setzt es in die passende
	Funktion ein AB*/
double mathe_funktion(double x, ELEMENT*pointer)
	{
	double argument =
		auswert(x, pointer->next,
				(pointer->typ==FKT) ? kl_zu(pointer) : pointer->ptr);
	if(geht_nicht) return(0.);
	switch(pointer->typ)
		{
		case SIN:
			return(sin(argument));
		case COS:
			return(cos(argument));
		case TAN:
			return(tan(argument));
		case WURZEL:
			if(argument<=0.)
				{
				geht_nicht=1;
				return(0.);
				}
			return(sqrt(argument));
		case EXP:
			return(exp(argument));
		case LN:
			if(argument<=0.)
				{
				geht_nicht=1;
				return(0.);
				}
			return(log(argument));
		case LOG10:
			if(argument<=0.)
				{
				geht_nicht=1;
				return(0.);
				}
			return(log10(argument));
		case ABS:
			return(fabs(argument));
		case SINH:
			return(sinh(argument));
		case COSH:
			return(cosh(argument));
		case TANH:
			return(tanh(argument));
		case ASIN:
			if(argument>1. || argument<-1.)
				{
				geht_nicht=1;
				return(0.);
				}
			return(asin(argument));
		case ACOS:
			if(argument>1. || argument<-1.)
				{
				geht_nicht=1;
				return(0.);
				}
			return(acos(argument));
		case ATAN:
			return(atan(argument));
		case FKT:
			return(auswert(argument, pointer->ptr, NULL));
		default:
			fatal_error("Typ > FKT nicht bekannt");
		}
	geht_nicht=1;
	return(0.);
	}

/* Die Funktion zum ausrechnen eines Funktionswertes AB*/
double auswert(double x, ELEMENT*erstes, ELEMENT*letztes)
	{
	double wert  = 0.;
	double mult_sp = 1.;
	double pot_sp  = (erstes->typ&RECHENZEICHEN)? 0. : 1.;
	double zwi_sp;
	ELEMENT*pointer;
	int akt_typ;
	char rechnen = 0;

	for(pointer = erstes; pointer!=letztes; pointer = pointer->next)
		{
		akt_typ = pointer->typ;
		if(geht_nicht) return(0.);

		if(akt_typ & RECHENZEICHEN)
			{
			if(rechnen & POTENZIEREN) fatal_error("convert oder Eingabe-String;"
						"Potenzieren zum falschen Zeitpunkt gesetzt");
			switch(akt_typ)
				{
				case PLUS:
					if(rechnen & DIVIDIEREN)
						{
						if(pot_sp==0.) {geht_nicht=1; return(0.);}
						mult_sp /= pot_sp;
						}
					else mult_sp *= pot_sp;
					if(rechnen & SUBTRAHIEREN)
						wert -= mult_sp;
					else wert += mult_sp;
               rechnen = 0;
					mult_sp = 1.;
					pot_sp  = 1.;
               break;
				case MINUS:
					if(rechnen & DIVIDIEREN)
						{
						if(pot_sp==0.) {geht_nicht=1; return(0.);}
						mult_sp /= pot_sp;
						}
					else mult_sp *= pot_sp;
					if(rechnen & SUBTRAHIEREN)
						wert -= mult_sp;
					else wert += mult_sp;
               rechnen = SUBTRAHIEREN;
					mult_sp = 1.;
					pot_sp  = 1.;
               break;
				case MAL:
					if(rechnen & DIVIDIEREN)
						{
						if(pot_sp==0.) {geht_nicht=1; return(0.);}
						mult_sp /= pot_sp;
						}
					else mult_sp *= pot_sp;
					rechnen &= ~DIVIDIEREN;
					pot_sp = 1.;
					break;
				case GETEILT:
					if(rechnen & DIVIDIEREN)
						{
						if(pot_sp==0.) {geht_nicht=1; return(0.);}
						mult_sp /= pot_sp;
						}
					else mult_sp *= pot_sp;
					rechnen |= DIVIDIEREN;
					pot_sp = 1.;
					break;
				case HOCH:
					rechnen |= POTENZIEREN;
					break;
				default:
				fatal_error("convert oder Rechenzeichen in plotsym.h");
				}
			continue;
			}
		if(akt_typ & FKT)
			{
			if(pointer->ptr==NULL)
				{
				printf("\aconvert hat geschlampt!");
				pointer->ptr = kl_zu(pointer);
				}
			zwi_sp = mathe_funktion(x, pointer);
			if(akt_typ > FKT)
				pointer   = pointer->ptr;
			else pointer = kl_zu(pointer);
			}
		else switch(akt_typ)
			{
			case KONSTANTE:
				zwi_sp = * (double*)pointer->ptr;
				break;
			case VAR_X:
				zwi_sp = x;
				break;
			case KLAMMER_AUF:
				if(pointer->ptr==NULL)
					{
					printf("\aconvert hat geschlampt!");
					pointer->ptr = kl_zu(pointer);
					}
				zwi_sp = auswert(x, pointer->next, pointer->ptr);
				pointer = pointer->ptr;
				break;
			default:
				printf(" %d ", akt_typ);
				fatal_error("Ein unbekannter Wert oder NICHTS (kein Rechenzeichen)");
			}
		if(rechnen & POTENZIEREN)
			{
			if(pot_sp<0 && !ifganz(zwi_sp))
				{
				geht_nicht=1;
				return(0.);
				}
			pot_sp = pow(pot_sp, zwi_sp);
			rechnen &= ~POTENZIEREN;
			continue;
			}
		if(rechnen & DIVIDIEREN)
			{
			if(pot_sp==0.) {geht_nicht=1; return(0.);}
			mult_sp /= pot_sp;
			}
		else mult_sp *= pot_sp;
		pot_sp = zwi_sp;
		continue;
		}
   if(rechnen & DIVIDIEREN)
		{
		if(pot_sp==0) {geht_nicht=1; return(0.);}
		mult_sp /= pot_sp;
		}
	else mult_sp *= pot_sp;
	if(rechnen & SUBTRAHIEREN)
		wert -= mult_sp;
	else wert += mult_sp;
   return(wert);
	}


/* erzeugt das Koordinatensystem auf dem Bildschirm */
void zeichne_koordinaten(double x_step, double y_step)
	{
	int i, j, y_wert, x_wert, x_dezi, y_dezi;
	long zaehler, zaehler2;
	int x_zaehlen = 1;
	int y_zaehlen = 1;
	int zeile, x_stelle, x_last = 0, x_compare = -2;

	double x_sprung, y_sprung;

	if(y_top >= 0. && y_bottom <= 0.)            /* x-Achse zeichnen*/
		y_wert = y_pixel(0.);
	else if(y_top > 0) y_wert = maxy;
		else y_wert = 0;

	for(i=0; i<=maxx; i++)
		zeichne_punkt(i, y_wert, KS_FARBE);

	x_sprung = X_ABSTAND * x_step;				 /* x-Achsen-Einteilung */
	x_dezi= floor(log10(x_sprung));
	if(x_sprung >= 7.5 * pow(10, x_dezi))
		x_dezi++;
	else if(x_sprung > 2.5 * pow(10, x_dezi))
		x_zaehlen = 5;

	zeile= (int)floor((double)y_wert/TEXTHOEHE)+1;
	if((zeile+1) * TEXTHOEHE >= maxy) zeile-=2;

	if(x_right >= 0. && x_left <= 0.)					/* y-Achse zeichnen */
		x_wert = x_pixel(0.);
	else if(x_left > 0) x_wert = 0;
		else x_wert = maxx;

	for(i=0; i<=maxy; i++)
		zeichne_punkt(x_wert, i, KS_FARBE);

	y_sprung = Y_ABSTAND * y_step;               /* y-Achsen-Einteilung */
	y_dezi= floor(log10(y_sprung));
	if(y_sprung >= 7.5 * pow(10, y_dezi))
		y_dezi++;
	else if(y_sprung > 2.5 * pow(10, y_dezi))
		y_zaehlen=5;


	if(x_wert && x_wert<maxx)                      /* Einteilung x-Achse zeich*/
		{
		x_compare = maxspalte+2;
		for(zaehler = -1; zaehler*x_zaehlen*pow(10, x_dezi) >= x_left; zaehler--)
			{
			i = x_pixel(zaehler*x_zaehlen*pow(10,x_dezi));
			if(x_pixel(x_zaehlen*pow(10,x_dezi))-x_pixel(0.)<=X_ABSTAND/2 && zaehler%2)
				continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(y_wert-j>=0) zeichne_punkt(i, y_wert-j, KS_FARBE);
				if(y_wert+j<=maxy) zeichne_punkt(i, y_wert+j, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler-1)*x_zaehlen*pow(10, x_dezi) >=x_left)
				{
				x_stelle = (int)floor((double)i/TEXTBREITE);
				x_stelle-= (int)floor(
						stellenzahl((x_zaehlen==1) ? zaehler : zaehler/2)/2);
				if(x_stelle + stellenzahl((x_zaehlen==1) ?
								zaehler : zaehler/2) < x_compare)
					{
					CUP(zeile, x_stelle);
					printf("%ld", (x_zaehlen==1) ? zaehler : zaehler/2);
					x_compare = x_stelle;
					}
				}
			}

		x_compare = -2;
		for(zaehler=1; zaehler*x_zaehlen*pow(10, x_dezi) <= x_right; zaehler++)
			{
			i = x_pixel(zaehler*x_zaehlen*pow(10,x_dezi));
			if(x_pixel(x_zaehlen*pow(10,x_dezi))-x_pixel(0.)<=X_ABSTAND/2 && zaehler%2) continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(y_wert-j>=0) zeichne_punkt(i, y_wert-j, KS_FARBE);
				if(y_wert+j<=maxy) zeichne_punkt(i, y_wert+j, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler+1)*x_zaehlen*pow(10,x_dezi) <=x_right)
				{
				x_stelle = (int)floor((double)i/TEXTBREITE);
				x_stelle-= (int)floor(
						stellenzahl((x_zaehlen==1) ? zaehler : zaehler/2)/2);

				if(x_stelle - x_compare > 0)
					{
					CUP(zeile, x_stelle);
					printf("%ld", (x_zaehlen==1) ? zaehler : zaehler/2);
					x_last = x_stelle;
					x_compare = x_stelle +
							stellenzahl((x_zaehlen==1) ? zaehler : zaehler/2);
					}
				}
			}

		x_stelle = (int)floor((double)(maxx+1)/TEXTBREITE)
					- stellenzahl((x_zaehlen==1) ? x_dezi : x_dezi+1)-3;
		if(x_dezi && x_zaehlen==1)
			{
			if(x_stelle - x_compare < 1)
				{
				CUP(zeile, x_last);
				for(i=x_last; i<=x_stelle; i++)
					putchar(' ');
				}
			CUP(zeile, x_stelle);
			printf("10^%d", x_dezi);
			}
		else if(x_zaehlen==5 && x_dezi+1)
			{
			if(x_stelle - x_compare < 1)
				{
				CUP(zeile, x_last);
				for(i=x_last; i<=x_stelle; i++)
					putchar(' ');
				}
			CUP(zeile, x_stelle);
			printf("10^%d", x_dezi+1);
			}
		}
	else
		{
		x_compare = -2;
		for(zaehler = ceil(x_left/x_zaehlen/pow(10,x_dezi)); zaehler*x_zaehlen*pow(10,x_dezi) <= x_right; zaehler++)
			{
			i = x_pixel(zaehler*x_zaehlen*pow(10,x_dezi));
			if(x_pixel(x_zaehlen*pow(10,x_dezi))-x_pixel(0.)<=X_ABSTAND/2 && zaehler%2)
				continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(y_wert-j>=0) zeichne_punkt(i, y_wert-j, KS_FARBE);
				if(y_wert+j<=maxy) zeichne_punkt(i, y_wert+j, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler-1)*x_zaehlen*pow(10, x_dezi) >= x_left
					&& (zaehler+1)*x_zaehlen*pow(10, x_dezi) <= x_right)
				{
				x_stelle = (int)floor((double)i/TEXTBREITE);
				x_stelle-= (int)floor(
						stellenzahl((x_zaehlen==1) ? zaehler : zaehler/2)/2);

				if(x_stelle - x_compare > 0)
					{
					CUP(zeile, x_stelle);
					printf("%ld", (x_zaehlen==1) ? zaehler : zaehler/2);
					x_last = x_stelle;
					x_compare = x_stelle +
							stellenzahl((x_zaehlen==1) ? zaehler : zaehler/2);
					}
				}
			}

		x_stelle = (x_wert==maxx) ? 0 :
				(int)floor((double)(maxx+1)/TEXTBREITE)
					- stellenzahl((x_zaehlen==1) ? x_dezi : x_dezi+1)-3;
		if(x_dezi && x_zaehlen==1)
			{
			if(x_stelle != 0)
				{
				if(x_stelle - x_compare < 1)
					{
					CUP(zeile, x_last);
					for(i=x_last; i<=x_stelle; i++)
						putchar(' ');
					}
				}
			CUP(zeile, x_stelle);
			printf((x_stelle!=0) ? "10^%d" : "10^%d ", x_dezi);
			}
		else if(x_zaehlen==5 && x_dezi+1)
			{
			if(x_stelle != 0)
				{
				if(x_stelle - x_compare < 1)
					{
					CUP(zeile, x_last);
					for(i=x_last; i<=x_stelle; i++)
						putchar(' ');
					}
				}
			CUP(zeile, x_stelle);
			printf((x_stelle!=0) ? "10^%d" : "10^%d ", x_dezi+1);
			}
		}


	zeile = (y_wert<TEXTHOEHE) ? maxzeile-1 : 0;
	x_stelle=(int)floor((double)x_wert/TEXTBREITE)+1;

	if(y_wert && y_wert<maxy)                      /* Einteilung y-Achse zeich*/
		{
		for(zaehler=1; zaehler*y_zaehlen*pow(10,y_dezi) <= y_top; zaehler++)
			{
			i = y_pixel(zaehler*y_zaehlen*pow(10,y_dezi));
			if(y_pixel(0)-y_pixel(y_zaehlen*pow(10,y_dezi))<=X_ABSTAND/2 && zaehler%2)
				continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(x_wert-j>=0) zeichne_punkt(x_wert-j, i, KS_FARBE);
				if(x_wert+j<=maxx) zeichne_punkt(x_wert+j, i, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler+1)*y_zaehlen*pow(10, y_dezi) <=y_top)
				{
				if((x_stelle+floor((y_zaehlen==1) ? log10(zaehler) : log10(zaehler/2) )
						+2)>=((double)maxx/TEXTBREITE))
					x_stelle = floor((double)maxx/TEXTBREITE)-1-floor(
						(y_zaehlen==1) ? log10(zaehler) : log10(zaehler/2) );

				CUP((int)floor((double)i/TEXTHOEHE), x_stelle);

				printf("%ld", (y_zaehlen==1) ? zaehler : zaehler/2);
				}
			}

		for(zaehler=-1; zaehler*y_zaehlen*pow(10, y_dezi) >= y_bottom; zaehler--)
			{
			i = y_pixel(zaehler*y_zaehlen*pow(10,y_dezi));
			if(y_pixel(0)-y_pixel(y_zaehlen*pow(10,y_dezi))<=X_ABSTAND/2 && zaehler%2)
				continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(x_wert-j>=0) zeichne_punkt(x_wert-j, i, KS_FARBE);
				if(x_wert+j<=maxx) zeichne_punkt(x_wert+j, i, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler-1)*y_zaehlen*pow(10, y_dezi) >=y_bottom)
				{
				if((x_stelle+floor((y_zaehlen==1) ? log10(labs(zaehler)) : log10(labs(zaehler/2)) )
						+2)>=((double)maxx/TEXTBREITE))
					x_stelle = floor((double)maxx/TEXTBREITE)-2-floor(
						(y_zaehlen==1) ? log10(labs(zaehler)) : log10(labs(zaehler/2)) );

				CUP((int)floor((double)i/TEXTHOEHE), x_stelle);

				printf("%ld", (y_zaehlen==1) ? zaehler : zaehler/2);
				}
			}

		if(y_dezi && y_zaehlen==1)
			{
			if((x_stelle+floor(log10(abs(y_dezi)))+5
					)>=((double)maxx/TEXTBREITE))
				x_stelle = maxx/TEXTBREITE-5-floor(log10(abs(y_dezi)))+(y_dezi>0);
			CUP(zeile, x_stelle);
			printf("10^%d", y_dezi);
			}
		else if(y_dezi+1 && y_zaehlen==5)
			{
			if((x_stelle+floor(log10(abs(y_dezi+1)))+5
					)>=((double)maxx/TEXTBREITE))
				x_stelle = maxx/TEXTBREITE-5-floor(log10(abs(y_dezi+1)))+(y_dezi>0);
			CUP(zeile, x_stelle);
			printf("10^%d", y_dezi+1);
			}
		}

	else
		{
		for(zaehler = ceil(y_bottom/y_zaehlen/pow(10, y_dezi));
            zaehler*y_zaehlen*pow(10,y_dezi) <= y_top; zaehler++)
			{
			i = y_pixel(zaehler*y_zaehlen*pow(10,y_dezi));
			if(y_pixel(0)-y_pixel(y_zaehlen*pow(10,y_dezi))<=X_ABSTAND/2 && zaehler%2)
				continue;

			for(j=1; j<=KS_DICKE; j++)
				{
				if(x_wert-j>=0) zeichne_punkt(x_wert-j, i, KS_FARBE);
				if(x_wert+j<=maxx) zeichne_punkt(x_wert+j, i, KS_FARBE);
				}

			if((zaehler%2)==0 && (zaehler+1)*y_zaehlen*pow(10, y_dezi) <=y_top
					&& (zaehler-1)*y_zaehlen*pow(10, y_dezi) >=y_bottom)
				{
				if((x_stelle+floor((y_zaehlen==1) ? log10(labs(zaehler)) : log10(labs(zaehler/2)) )
						+2)>=((double)maxx/TEXTBREITE))
					x_stelle = floor((double)maxx/TEXTBREITE)-1-(zaehler<0)-floor(
						(y_zaehlen==1) ? log10(labs(zaehler)) : log10(labs(zaehler/2)) );

				CUP((int)floor((double)i/TEXTHOEHE), x_stelle);

				printf("%ld", (y_zaehlen==1) ? zaehler : zaehler/2);
				}
			}
		if(y_dezi && y_zaehlen==1)
			{
			if((x_stelle+floor(log10(abs(y_dezi)))+5
					)>=((double)maxx/TEXTBREITE))
				x_stelle = maxx/TEXTBREITE-5-floor(log10(abs(y_dezi)))+(y_dezi>0);
			CUP( zeile, x_stelle);
			printf("10^%d", y_dezi);
			}
		else if(y_dezi+1 && y_zaehlen==5)
			{
			if((x_stelle+floor(log10(abs(y_dezi+1)))+5
					)>=((double)maxx/TEXTBREITE))
				x_stelle = maxx/TEXTBREITE-5-floor(log10(abs(y_dezi+1)))+(y_dezi>0);
			CUP( zeile, x_stelle);
			printf("10^%d", y_dezi+1);
			}
		}

	for(zaehler = ceil(x_left/2/x_zaehlen/pow(10,x_dezi));
			zaehler*2*x_zaehlen*pow(10,x_dezi) <= x_right; zaehler++)
		{
		i = x_pixel(zaehler*2*x_zaehlen*pow(10, x_dezi));
		for(zaehler2 = ceil(y_bottom/2/y_zaehlen/pow(10, y_dezi));
				zaehler2*2*y_zaehlen*pow(10,y_dezi) <= y_top; zaehler2++)
			{
			j = y_pixel(zaehler2*2*y_zaehlen*pow(10, y_dezi));
			zeichne_punkt(i,j,KS_FARBE);
			}
		}

	}

void verbinde(int y1, int y2, int x, int farbe)
	{
	int i, ubergang;
	if(x<0)
		{
		if(y1 > y2)
			{
			i = y1;
			y1= y2;
			y2= i;
			}
      x = -x;
		for(i = y1+1; i < y2; i++)
			zeichne_punkt(x, i, farbe);
		return;
		}
	ubergang = (y1 + y2 + 1) / 2;
	if(y1<y2)
		{
		for(i = y1+1; i < ubergang; i++)
			zeichne_punkt(x-1, i, farbe);
		for(; i < y2; i++)
			zeichne_punkt(x, i, farbe);
		return;
		}
	for(i = y1 - 1; i > ubergang; i--)
		zeichne_punkt(x-1, i, farbe);
	for(; i > y2; i--)
		zeichne_punkt(x, i, farbe);
	}

int zeichne_funktion(int fkt_number, double x_step, double y_step, int farbe)
	{
	double wert, last_wert=0., last2_wert=0.;
	int y_wert = KEIN_WERT, y_last = KEIN_WERT, y_2last = KEIN_WERT;
	int i, verbunden = 1;
	if(anzeigen[fkt_number] == 0) return -1;
	if(x_step==0.)
		{
		x_step = fabs(x_right - x_left) / maxx;
		y_step = fabs(y_top - y_bottom) / maxy;
		}

	for(i = 0; i <= maxx; i++)
		{
		if(tastendruck()) if(taste()==ABBRUCH) exit(0);
		geht_nicht = 0;
		wert = auswert(x_left + i*x_step, f[fkt_number], NULL);

		if(!geht_nicht)
			{
			if(!verbunden && y_2last != KEIN_WERT)
				{
				if(last2_wert < last_wert && last_wert < wert)
					{
					if(!(y_last < 0 && y_last == y_2last))
						{
						switch(y_2last)
							{
							case UNTEN_HINAUS:
								verbinde(maxy+1, (y_last>=0) ? y_last : -1, i-1, farbe);
								break;
							default:
								switch(y_last)
									{
									case OBEN_HINAUS:
										verbinde(y_2last, -1, i-1, farbe);
										break;
									default:
										verbinde(y_2last, y_last, i-1, farbe);
									}
							}
						}
					}
				else if(last2_wert > last_wert && last_wert > wert)
					{
					if(!(y_last < 0 && y_last == y_2last))
						{
						switch(y_2last)
							{
							case OBEN_HINAUS:
								verbinde(-1, (y_last>=0) ? y_last : maxy+1, i-1, farbe);
								break;
							default:
								switch(y_last)
									{
									case UNTEN_HINAUS:
										verbinde(y_2last, maxy+1, i-1, farbe);
										break;
									default:
										verbinde(y_2last, y_last, i-1, farbe);
									}
							}
						}
					}
				}

			if(wert >= y_bottom && wert <= y_top)
				{
				y_wert = y_pixel(wert);
				zeichne_punkt(i, y_wert, farbe);
				if(abs(y_last - y_wert) >1)
					{
					verbunden = 0;
					if(y_last<0)
						{
						if(y_last!=KEIN_WERT && y_2last != KEIN_WERT)
							switch(y_last)
								{
								case UNTEN_HINAUS:
									if(last2_wert<last_wert)
										{
										verbinde(maxy+1, y_wert, -i, farbe);
										verbunden = 1;
										}
									break;
								case OBEN_HINAUS:
									if(last2_wert>last_wert)
										{
										verbinde(-1, y_wert, -i, farbe);
										verbunden = 1;
										}
									break;
								}
						}
					else
						{
						if(y_2last != KEIN_WERT && (
								(y_last < y_wert && last2_wert > last_wert) ||
								(y_last > y_wert && last2_wert < last_wert)))
							{
							verbinde(y_last, y_wert, i, farbe);
							verbunden = 1;
							}
						}
					}
				else verbunden = 1;
				y_2last = y_last;
				y_last = y_wert;

				last2_wert = last_wert;
				last_wert = wert;
				}
			else
				{
				verbunden = 0;
				if(y_last >= 0)
					{
					if(y_2last != KEIN_WERT && ((wert < y_bottom && last2_wert > last_wert) ||
							(wert > y_top && last2_wert < last_wert)))
						{
						verbinde(y_last, (wert < y_bottom) ? maxy+1 : -1, -(i-1), farbe);
						verbunden = 1;
						}
					}
				else if(y_last != KEIN_WERT && y_2last != KEIN_WERT &&
						((wert > y_top && y_last == UNTEN_HINAUS && last2_wert < last_wert)
							|| (wert < y_bottom && y_last == OBEN_HINAUS
													&& last2_wert > last_wert)))
						{
						if(y_last == UNTEN_HINAUS && wert > y_top)
							{
							verbinde(maxy+1, -1, i, farbe);
							verbunden = 1;
							}
						else if(y_last == OBEN_HINAUS && wert < y_bottom)
							{
							verbinde(-1, maxy+1, i, farbe);
							verbunden = 1;
							}
						}
				y_2last = y_last;
				y_last = (wert < y_bottom) ? UNTEN_HINAUS : OBEN_HINAUS;

				last2_wert = last_wert;
				last_wert = wert;
				}
			}
		else
			{
			verbunden = 1;
			y_2last = y_last;
			y_last = KEIN_WERT;

			last2_wert = last_wert;
			last_wert = 0.;
			}
		}
	return(0);
	}

int zeichnen(void)
	{
	double x_step;
	double y_step;
	int i;
	x_step = fabs(x_right - x_left) / maxx;
	y_step = fabs(y_top - y_bottom) / maxy;

	ED;
	zeichne_koordinaten(x_step, y_step);
	for(i=F_MAX-1; i>=0; i--)
		zeichne_funktion(i, x_step, y_step, 15/*FARBE(i)*/);
	return(0);
	}

void erase_zeile(int nummer)
	{
	int i;
	CUP(nummer, 0);
	for(i = maxspalte-1; i; i--)
		putchar(' ');
	}

void farb_punkt(int farbe)
	{
	int i,j;
	for(i = PIXEL_X>>8; i<= (PIXEL_X & 0xFF); i++)
		for(j = PIXEL_Y>>8; j<= (PIXEL_Y & 0xFF); j++)
			zeichne_punkt(i, maxzeile*TEXTHOEHE + j, farbe);
	}

void zeile(int fkt_nummer)
	{
	if(anzeigen[fkt_nummer] == 0)
		{
		fkt_nummer++;
		while(anzeigen[fkt_nummer%F_MAX] == 0)
			{
			fkt_nummer++;
			if(fkt_nummer >= F_MAX*2) return;
			}
		fkt_nummer %= F_MAX;
		}

	erase_zeile(maxzeile);
	if(difcolour) farb_punkt(FARBE(fkt_nummer));
	CUP(maxzeile, 2);
	printf("F%c = ", fkt_nummer+'0');
	printf(f_string[fkt_nummer]);
	}

/* schmeit berflssige KLAMMER_AUF raus und prft Klammer-Ebenen */
/* und setzt ntige KLAMMER_ZUs ein */
int optimize(int nummer)
	{
	ELEMENT *elm;
	int i;
	int kla_ebene = 0;
	int akt_typ;
	for( elm = f[nummer]; elm != NULL ; elm = elm->next )
		{
		akt_typ = elm->typ;
		if(akt_typ & FKT)
			{
			kla_ebene++;
			if((elm->next)->typ == KLAMMER_AUF)
				{
				elm->next->typ = NICHTS;
				elm->next->ptr = NULL;
				elm->next = (elm->next)->next;
				}
			else if(elm->next->typ == VAR_X || elm->next->typ == KONSTANTE)
				{
				for(i=MAX_ELEMENTE-1; f[nummer][i].typ != NICHTS &&
						i>=0; i--) ;
				if(i<0)
					{
					printf("\nGeht nicht!");
					return -1;
					}
				f[nummer][i].typ = KLAMMER_ZU;
				f[nummer][i].next= elm->next->next;
				elm->next->next = &f[nummer][i];
				}
			else
				{
				printf("\nBitte gib die Funktion richtig ein!");
				return(-1);
				}
			}
		else switch(akt_typ)
			{
			case KLAMMER_AUF:
				kla_ebene++;
				break;
			case KLAMMER_ZU:
				kla_ebene--;
				if(kla_ebene < 0)
					{
					printf("zuviel(e) KLAMMER_ZU");
					return -1;
					}
			}
		}
	if(kla_ebene != 0)
		{
		printf("falsche Klammern!! %d", kla_ebene);
		return -1;
		}

	for( elm = f[nummer]; elm!=NULL ;elm = elm->next )
		{
		akt_typ = elm->typ;
		if((akt_typ & FKT && akt_typ != FKT) || akt_typ == KLAMMER_AUF)
			{
			elm->ptr = (void*)kl_zu(elm);
			if(elm->ptr==NULL)	return -1;
			}
		}
	return 0;
	}

void klein_buchst(char *str)
{
	int a;

	for( a = 0 ; str[a] != 0 ; a++ )
		if( str[a] >= 'A' && str[a] <= 'Z')
			str[a] += 0x20;
}

/* Rckgabe bereinstimmende Lnge, -1 falls bereinstimmung ber ganz str1 */
int str_vergleich(const char *str1, const char *str2)
{
	int a = 0;

	while( str1[a] == str2[a] && str1[a] != 0 && str2[a] != 0 ) {
		a++;
	}
	if( str1[a] == 0)
		a = -1;

	return a;
}

int kill_spaces(char *str)
{
	int a, b = 0;

	for( a = 0 ; str[a] != 0 ; a++ )
		if( str[a] != ' ' )
			str[b++] = str[a];
	str[b] = 0;
	return a - b;
}

int convert(int nummer)
{
	int f_count = 0;
	int c_count = 0;
	int i = 0;
	int nr;
	char *ptr;

	klein_buchst( f_string[nummer]);

	init_fkt(nummer);

	for( i = 0 ; f_string[nummer][f_count] != 0 ; i++ ) {
		switch( f_string[nummer][f_count] ) {
			case '(':
			case '[':
			case '{':
				f[nummer][i].typ = KLAMMER_AUF;
				break;
			case ')':
			case ']':
			case '}':
				f[nummer][i].typ = KLAMMER_ZU;
				break;
			case 'x':
				f[nummer][i].typ = VAR_X;
				break;
			case '+':
				f[nummer][i].typ = PLUS;
				break;
			case '-':
				f[nummer][i].typ = MINUS;
				break;
			case '*':
				f[nummer][i].typ = MAL;
				break;
			case '/':
			case ':':
				f[nummer][i].typ = GETEILT;
				break;
			case '^':
				f[nummer][i].typ = HOCH;
				break;
		}
		if( f[nummer][i].typ != NICHTS ) {
			f_count++;
			continue;
		}
		if( f_string[nummer][f_count] >= 'a' &&
				f_string[nummer][f_count] <= 'z' ) {
			if( str_vergleich( ABS_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = ABS;
				f_count += (int)strlen( ABS_STR);
			} else
			if( str_vergleich( ACOS_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = ACOS;
				f_count += (int)strlen( ACOS_STR);
			} else
			if( str_vergleich( ASIN_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = ASIN;
				f_count += (int)strlen( ASIN_STR);
			} else
			if( str_vergleich( ATAN_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = ATAN;
				f_count += (int)strlen( ATAN_STR);
			} else
			if( str_vergleich( COSH_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = COSH;
				f_count += (int)strlen( COSH_STR);
			} else
			if( str_vergleich( COS_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = COS;
				f_count += (int)strlen( COS_STR);
			} else
			if( str_vergleich( EXP_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = EXP;
				f_count += (int)strlen( EXP_STR);
			} else
			if( str_vergleich( LN_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = LN;
				f_count += (int)strlen( LN_STR);
			} else
			if( str_vergleich( LOG10_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = LOG10;
				f_count += (int)strlen( LOG10_STR);
			} else
			if( str_vergleich( SINH_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = SINH;
				f_count += (int)strlen( SINH_STR);
			} else
			if( str_vergleich( SIN_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = SIN;
				f_count += (int)strlen( SIN_STR);
			} else
			if( str_vergleich( WURZEL_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = WURZEL;
				f_count += (int)strlen( WURZEL_STR);
			} else
			if( str_vergleich( TANH_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = TANH;
				f_count += (int)strlen( TANH_STR);
			} else
			if( str_vergleich( TAN_STR, &f_string[nummer][f_count])
					== -1 ) {
				f[nummer][i].typ = TAN;
				f_count += (int)strlen( TAN_STR);
			} else
			if( str_vergleich( E_STR, &f_string[nummer][f_count])
					== -1 ) {
				if(c_count >= MAX_DOUBLES)
					{
					printf("zu viele doubles!!");
					return -1;
					}
				ptr = &f_string[nummer][f_count];
				constants[nummer][c_count] = M_E;

				f[nummer][i].typ = KONSTANTE;
				f[nummer][i].ptr = (void *) &constants[nummer][c_count];
				c_count++;
				f_count += (int)strlen( E_STR);
			} else
			if( str_vergleich( PI_STR, &f_string[nummer][f_count])
					== -1 ) {
				if(c_count >= MAX_DOUBLES)
					{
					printf("zu viele doubles!!");
					return -1;
					}
				ptr = &f_string[nummer][f_count];
				constants[nummer][c_count] = M_PI;

				f[nummer][i].typ = KONSTANTE;
				f[nummer][i].ptr = (void *) &constants[nummer][c_count];
				c_count++;
				f_count += (int)strlen( PI_STR);
			} else
			if( f_string[nummer][f_count] == 'f' ) {
				nr = f_string[nummer][f_count+1] - '0';
				if( nr < 0 || nr >= nummer ) {
					printf("Bitte gib den Funktionsterm richtig ein!\n");
					return (int)f_count+1;
				}
				f[nummer][i].typ = FKT;
				f[nummer][i].ptr = f[nr];
				f_count += 2;
			}
			if( f[nummer][i].typ != NICHTS )
				continue;
			else {
				printf("\n* Fehler!!! (keine bekannte Funktion!)\n"
							"%s", &f_string[nummer][f_count]);
				return -1;
			}
		}

		if(c_count >= MAX_DOUBLES)
			{
			printf("zu viele doubles!!");
			return -1;
			}
		ptr = &f_string[nummer][f_count];
		constants[nummer][c_count] =
				strtod( &f_string[nummer][f_count], &ptr);
		f[nummer][i].typ = KONSTANTE;
		f[nummer][i].ptr = (void *) &constants[nummer][c_count];
		f_count += (int)(ptr - &f_string[nummer][f_count]);
		if( *(ptr - 1) == 'e' )
			f_count--;
		c_count++;

	}
	f[nummer][i-1].next = NULL;
	return(optimize(nummer));
}

int main(void)
	{
	int i, k, anzahl;
	int ende=0;
	int alles_zeichnen=1;

	plot_init();
	ED;
	printf("Wie viele Funktionen sollen gezeichnet werden? (1-%d,"
				" 0 fr Abbruch)\n", F_MAX);
	do
		scanf("%d", &anzahl);
	while( anzahl < 0 || anzahl > F_MAX );

	if(anzahl==0) exit(0);

	for( i = 0 ; i < anzahl ; i++ ) {
		do {
			printf("\nF%d = ", i);
			scanf("%s", f_string[i]);
		} while( convert( i));
		anzeigen[i] = 1;
	}

/*	do{
		printf("\nLinker Rand bei x = ");
		scanf("%lf", &x_left);
		printf("\nRechter Rand bei x = ");
		scanf("%lf", &x_right);
	} while( x_right < x_left+.001);
	do{
		printf("\nUnterer Rand bei y = ");
		scanf("%lf", &y_bottom);
		printf("\nOberer Rand bei y = ");
		scanf("%lf", &y_top);
	} while( y_top < y_bottom+.001);
*/	if(x_left == PROPORTIONAL)
		x_left = x_right -
				(y_top-y_bottom)*
					(((double)(maxx+1))/((double)(maxy+1)))/Y_ZU_X;
	if(x_right == PROPORTIONAL)
		x_right = x_left +
				(y_top-y_bottom)*
					(((double)(maxx+1))/((double)(maxy+1)))/Y_ZU_X;
	if(y_bottom == PROPORTIONAL)
		y_bottom = y_top -
				(x_right-x_left)*
					(((double)(maxy+1))/((double)(maxx+1)))*Y_ZU_X;
	if(y_top == PROPORTIONAL)
		y_top = y_bottom +
				(x_right-x_left)*
					(((double)(maxy+1))/((double)(maxx+1)))*Y_ZU_X;

	screen_graphik();
	do {
		if(alles_zeichnen)
			{
			zeichnen();
			alles_zeichnen = 0;
			zeile(0);
			}
		k=taste();
		if(k>='0' && k < F_MAX+'0' && anzeigen[k-'0'])
			{
			if(difcolour)
				zeichne_funktion(k-'0', 0., 0., FARBE(k-'0'));
			zeile(k-'0');
			}
		else {
			alles_zeichnen = 1;
			switch( k) {
				case LINKS:
					x_left -= ( x_right - x_left ) / 3;
					x_right -= ( x_right - x_left ) / 4;
					break;
				case RECHTS:
					x_right += ( x_right - x_left ) / 3;
					x_left += ( x_right - x_left ) / 4;
					break;
				case OBEN:
					y_top += ( y_top - y_bottom ) / 3;
					y_bottom += ( y_top - y_bottom ) / 4;
					break;
				case UNTEN:
					y_bottom -= ( y_top - y_bottom ) / 3;
					y_top -= ( y_top - y_bottom ) / 4;
					break;
				case ZOOM_IN:
					if ( ( x_right - x_left ) < 0.0015 ||
						( y_top - y_bottom ) < 0.0015 ) break;
					x_left += ( x_right - x_left ) / 6;
					x_right -= ( x_right - x_left ) / 5;
					y_bottom += ( y_top - y_bottom ) / 6;
					y_top -= ( y_top - y_bottom ) / 5;
					break;
				case ZOOM_OUT:
					x_left -= ( x_right - x_left ) / 4;
					x_right += ( x_right - x_left ) / 5;
					y_bottom -= ( y_top - y_bottom ) / 4;
					y_top += ( y_top - y_bottom ) / 5;
					break;
				case ABBRUCH:
					ende = 1;
					break;
				default:
					alles_zeichnen = 0;
			}
		}
   } while( ende == 0 );
	screen_text();

	plot_exit();
	return 0;
	}
